import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;
import javax.swing.*;
import javax.swing.text.*;
import javax.swing.event.*;
/**
 * TextAreaPane represente la zone d'edition du document
 */
public class TextAreaPane extends JScrollPane
{	
  /**
   * gere la couche document vue
   */
  protected JDesktopPane desktop;
  /**
   * affiche le document 
   */
  protected JTextPane m_monitor;
  /**
   * le context d'affichage
   */
  protected StyleContext m_context; 
  /**
   * le document 
   */
  protected DefaultStyledDocument m_doc;
  /**
   * la gestion RTF du document 
   */
  protected StyledEditorKit m_kit;
  /**
   * le debut de la zone d'edition 
   */
  protected int deb_caret;
  /** 
   * la fin de la zone d'edition 
   */
  protected long mytime;
  protected int fin_caret;
  protected int nb_ligne;
  private int old_ligne;
  private int old_number_ligne;
  public TextAreaPaneListener listener;
  /**
   * la fenetre mere
   */
  protected MainFrame _master;
 protected int [] _hashtable;
  public int getNbLigne(){return nb_ligne;}
  public void scroll(int l)
  {
  JScrollBar _scroll=getVerticalScrollBar();
  if (_scroll==null) return;
  int max=_scroll.getMaximum();
  int nvalue=(l*max)/nb_ligne;
  System.err.println("Valeur de scroll : "+nvalue);
  _scroll.setValue(nvalue);
  repaint();
           

  }
  /**
   * rend le nombre de ligne entre le caractere debut et le caractere fin"
   */
    public int getNbLigne(int debut,int fin)
    {
    
     	 String d=getDocument();
        System.out.println("gereNbLigne");
        int count=0;
  if (d==null) return 0;
    if (debut<fin)
    {
     int l_debut= _hashtable[debut];
     int l_fin=_hashtable[fin];
     count=l_fin-l_debut;
    //for (int i=debut;i<d.length() && i<fin;i++) if (d.charAt(i)=='\n') count++;
    }
    return count;
    
}
/**
 * donne le numero de la ligne du charactere l
 */
   public int getLigne(int l)
  {
  String d=getDocument();
   System.out.println("gereLigne");
  if (d==null) {old_number_ligne=0;old_ligne=0;return 0;}
  /*int count=0;
  if (l>=old_ligne) 
  {
  count=old_number_ligne;
  for (int i=old_ligne;i<d.length() && i<l;i++) if (d.charAt(i)=='\n') count++;
}
else
{count=old_number_ligne;
  for (int i=l;i>0 && i>l;i--) if (d.charAt(i)=='\n') count--;
 
}
old_number_ligne=count;
old_ligne=l;*/
int count=_hashtable[l];
  return count;
  }
  public class Status 
  {
  MainFrame _master;
  String _test;
  int old_taille;
  int _count;
  int taille;
  /**
   * on passe au contructeur la fenetre mere et le document 
   */
  public Status(MainFrame master,String test,int l)
  {
  
  _master=master;
  taille=l;
  _test=test;
   old_taille=0;
   _count=0;
  }
  
  public void Init(String test,int l)
  {
  _test=test;
  taille=l;
  }
  /**
   * affiche la mention de la ligne 
   */

  public void start()
	 {
	 new Thread(){
	 	public void run(){
	 /*System.out.println("Status run");
	
	System.out.println("taille :"+taille+"old_taille"+old_taille);
	if (taille>=old_taille)
	{
	 for (int i=old_taille;i<taille;i++) if (_test.charAt(i)=='\n') _count++;
	}
	else
	{
	for (int i=taille;i<old_taille;i++) if (_test.charAt(i)=='\n') _count--;
	
	}
	old_taille=taille;*/
	if (_hashtable!=null){
	_count=_hashtable[taille];

	 if (_master!=null) _master.setStatus("Ligne :"+_count);
	 }
	 }
	}.start(); 
	 }
  }
  private Status _status;
  /**
   * gere la modification du document par rapport a l'emplacement des tags
   *
   */
 public class TextAreaPaneListener implements DocumentListener
 {
 ListeTag _tag;
 /**
  * on  passe la liste des tag en parametre 
  */
 public TextAreaPaneListener(ListeTag t)
 {
 _tag=t;
 }
 public  void
      changedUpdate(DocumentEvent e)  
      {
      System.out.println("changedUpdate 1");
       
      //  GereLigne();
      }
/** 
 * gere l'ajout dans le document 
 */
      public  void
      insertUpdate(DocumentEvent e) 
      {
      
     
      int taille=e.getLength(); 
      int where=e.getOffset();
       System.err.println("insertUpdate taille+"+taille+"where:"+where);
       _tag.AddText(where,taille,getNbLigne(where,where+taille));
        GereLigne();
	 // _master.UpDateTag();
      }
/**
 * gere le retrait de caractere dans le document 
 */
public  void
      removeUpdate(DocumentEvent e)
       {
       
      System.out.println("removeUpdate");
      int taille=e.getLength(); 
      int where=e.getOffset();
      _tag.RemoveText(where,taille,getNbLigne(where,where+taille));
        GereLigne();
        _master.UpDateListe();
       
       }
 public void setListeTag(ListeTag lt)
 {
 _tag=lt;
 }
 }
/**
 * le constructeur , on passe la fenetre mere en parametre 
 */
 public TextAreaPane(MainFrame master)  
{
	super(JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED,
	      JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);
	mytime=0;
	setSize(600, 400);
 	m_monitor = new JTextPane();
 	
	      _master=master;
	
 	m_kit = new StyledEditorKit();
  	m_monitor.setEditorKit(m_kit);
	m_context = new StyleContext();
	m_doc = new DefaultStyledDocument(m_context);
   	m_monitor.setDocument(m_doc);
   
    	m_monitor.setDoubleBuffered(true);
    	
	m_monitor.addCaretListener(new CaretListener()
	{
	 public void caretUpdate(CaretEvent e)
	 {
	try 
	{int x=0;
	int y=0;
	if (e.getDot()<=e.getMark()) {x=e.getDot();y=e.getMark();}
	else {y=e.getDot();x=e.getMark();}
	
	 deb_caret=x;
	 fin_caret=y;
	if (_status==null){
		
	_status=new Status(_master,getDocument(),deb_caret);
	_status.start();
	
}else
{
	_status.Init(getDocument(),deb_caret);
	_status.start();
}
	
	 
	 if (x==y) 
	 {
	 long now=System.currentTimeMillis();
	 if (Math.abs(mytime-now)<500)
	 {
	 System.err.println("On a double cliquer");
	}else {
		mytime=now;
		System.err.println("SimpleClick");
	}
	_master.UpDateChild(x);

	 }
	
	
	 System.out.println(e);} catch (Exception ev){};
	}
	}
	);
	
	
setViewportView(m_monitor);	
setVisible(true);
}
public void setListeTag(ListeTag tl)
{
	listener.setListeTag(tl);

}
public void setDot(int i)
{
m_monitor.getCaret().setDot(i);


}
/**
 * gere la selection d'un morceau de texte (passage en gras)
 */
public void  select(int selectionStart,
                   int selectionEnd,SimpleAttributeSet attr)
                {
            Color foreground=StyleConstants.getForeground(attr);
            Color background=StyleConstants.getBackground(attr);
            
                        SimpleAttributeSet result=new SimpleAttributeSet();
            StyleConstants.setForeground(result,Color.white);
            StyleConstants.setBackground(result,
            new Color(255-background.getRed(),
            		255-background.getGreen(),
            		255-background.getBlue())
            );    
                        setAttributeSet(result,selectionStart,selectionEnd);  
                
        }
/**
 * gere l'operation couper dans le document 
 */        
public void cut() {
        this.m_monitor.cut();
      }
/**
 * gere l'operation coller dans le document
 */
public void paste() {
        this.m_monitor.paste();
      }
/**
 * gere l'operation copy dans le document 
 */
public void copy() {
        this.m_monitor.copy();
      }
      
/**
 * permet de charger dans le document un fichier 
 */
public void load(File fChoosen)
{
try
{
	
	try{    
	StyledDocument d=m_monitor.getStyledDocument();
	d.remove (0,d.getLength());
	/*
 	m_kit = new StyledEditorKit();
  	m_monitor.setEditorKit(m_kit);
	m_context = new StyleContext();
	m_doc = new DefaultStyledDocument(m_context);
   	m_monitor.setDocument(m_doc);
   	setViewportView(m_monitor);*/
   	} catch(Exception ev) {}
   FileReader in = new FileReader(fChoosen);
   m_monitor.read(in, null);
   listener=new TextAreaPaneListener(_master.getTag());
   m_monitor.getStyledDocument().addDocumentListener(listener);
   
   in.close();	
  create_HashTable();
   GereLigne();
} 
catch (Exception f) {System.out.println(f);};
}

public void create_HashTable()
{
String s=getDocument();
int countmy=0;
_hashtable=new int[s.length()];

for (int i=0;i<s.length();i++)
{
if (s.charAt(i)=='\n') countmy++;
_hashtable[i]=countmy;
}
}
/**
 * renvoie le debut d'une zone selectionner
 */
public int get_debut(){return deb_caret;}
/** 
 * renvoie la fin d'une zone selectionner
 */
public int get_fin(){return fin_caret;}

/**
 * met a jour un morceau de document (entre debut et fin) avec un attribut graphique (attrM)
 * renvoie un booleen de controle
 */
public boolean  setAttributeSet(MutableAttributeSet attrM,int debut,int fin) 
{
   
System.out.println("debut :"+debut+" fin :"+fin);
    if ( debut != fin)
    {
      m_monitor.getStyledDocument().setCharacterAttributes(debut, fin - debut, 
        attrM, false);
        return true;
    } 
  return false;
}
/**
 * met a jour un morceau de document(entre debut et fin ) avec un attribut graphique d'une balise
 * renvoie un booleen de controle
 */
public boolean  setAttributeSet(Balise b,int debut,int fin) 
{
   return(setAttributeSet(b.getAttribut(),debut,fin));

}
/**
 * repaint tous les tags du document 
 */
public void repaintTag(ListeTag tag)
{
Clean();
for (int i=0;i<tag.getListeTag().size();i++)
{
Tag t=tag.get(i);

setAttributeSet(t.getBalise(),t.getDebut(),t.getFin());
}
}
/**
 * met a jour la selection(debut fin) avec un attribut graphique 
 */
public boolean  setAttributeSet(MutableAttributeSet attrM) 
{
   
System.out.println("debut :"+deb_caret+" fin :"+fin_caret);
    if ( deb_caret != fin_caret)
    {
      m_monitor.getStyledDocument().setCharacterAttributes(deb_caret, fin_caret - deb_caret, 
        attrM, false);
        return true;
    } 
  return false;
  }
/**
 * nettoie le document de tous les attributs graphiques
 */
public void  Clean() 
{
 MutableAttributeSet attr=new SimpleAttributeSet();



      m_monitor.getStyledDocument().setCharacterAttributes(0,m_monitor.getStyledDocument().getLength(), attr, true);
     
  }
  
private void GereLigne()
{

new Thread()
{
public void run()
{ int count=0;
String doc=getDocument();
	if (doc!=null)
	{_hashtable=new int[doc.length()];

 	for (int i=0;i<doc.length();i++) 
 	{if (doc.charAt(i)=='\n') count++;
 	_hashtable[i]=count;
	}
	TextAreaPane.this.nb_ligne=count;
	}
}
}.start();
}  
/**
 * reserve
 */  
public void GereFin(int i)
{
StyledDocument doc=m_monitor.getStyledDocument();
int taille=doc.getLength();
if (taille==i)
{
//doc.insert(
}
}
/**
 * renvoie la chaine de caractere representant le document 
 */
public String getDocument()
{
try
{StyledDocument d=m_monitor.getStyledDocument();
if (d==null) return "";
return (d.getText(0,d.getLength()));
}
catch (Exception b) {return new String("");}
}

public void setDocument(String df)
{
try
{

StyledDocument d=m_monitor.getStyledDocument();
try {d.remove (0,d.getLength());} catch (Exception ff) {};


d.insertString(0,df,new SimpleAttributeSet() );
create_HashTable();

}
catch (Exception b) {System.err.println(b);}
}

}
